org.eclipse.viatra.query.runtime.rete.construction.plancompiler

## Class CompilerHelper.JoinHelper

- java.lang.Object
- - org.eclipse.viatra.query.runtime.rete.construction.plancompiler.CompilerHelper.JoinHelper

- Enclosing class:
    CompilerHelper

      public static class CompilerHelper.JoinHelper
      extends java.lang.Object

  Calculated index mappings for a join, based on the common variables of the two parent subplans.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `JoinHelper(SubPlan planToCompile, PlanningTrace primaryCompiled, PlanningTrace callTrace)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `TupleMask` | `getComplementerMask()`
    `JoinRecipe` | `getNaturalJoinRecipe()`
    `java.util.List<PVariable>` | `getNaturalJoinVariablesTuple()`
    `RecipeTraceInfo` | `getPrimaryIndexer()`
    `TupleMask` | `getPrimaryMask()`
    `RecipeTraceInfo` | `getSecondaryIndexer()`
    `TupleMask` | `getSecondaryMask()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JoinHelper

          public JoinHelper(SubPlan planToCompile,
                            PlanningTrace primaryCompiled,
                            PlanningTrace callTrace)

  - ### Method Detail

    - #### getPrimaryMask

          public TupleMask getPrimaryMask()

    - #### getSecondaryMask

          public TupleMask getSecondaryMask()

    - #### getComplementerMask

          public TupleMask getComplementerMask()

    - #### getPrimaryIndexer

          public RecipeTraceInfo getPrimaryIndexer()

    - #### getSecondaryIndexer

          public RecipeTraceInfo getSecondaryIndexer()

    - #### getNaturalJoinRecipe

          public JoinRecipe getNaturalJoinRecipe()

    - #### getNaturalJoinVariablesTuple

          public java.util.List<PVariable> getNaturalJoinVariablesTuple()